--
-- Filtrira ulazni signal vremenskom zategom, te na rastuci brid
-- filtriranog signala generira impuls u trajanju jednog ciklusa takta
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity pulse is
    port (
	btn: in std_logic;
	clk: in std_logic;
	pulse: out std_logic
    );
end pulse;

architecture x of pulse is
    constant C_cnt_max: natural := 25000000 / 100;
    signal R_cnt: natural range 0 to C_cnt_max;
    signal R_btn_sync: std_logic;
    signal R_done: boolean;

begin
    process(clk)
    begin
	if rising_edge(clk) then
	    R_btn_sync <= btn;
	    pulse <= '0';
	    if R_cnt /= 0 then
		R_cnt <= R_cnt - 1;
	    else
		if not R_done then
		    pulse <= R_btn_sync;
		end if;
		R_done <= true;
	    end if;
	    if R_btn_sync = '0' then
		R_cnt <= C_cnt_max;
		R_done <= false;
	    end if;
	end if;
    end process;
end x;
